// PAC archive file extraction tool (specifically for use with one piece psp archives)
// IQ_132 - http://neosource.1emu.net
// License - http://creativecommons.org/licenses/by-nc/3.0/

// There is still a couple of unknown bits of data in the structure...
// One is almost definitely a checksum of some sort, but doesn't seem to be CRC32 or Checksum32.

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define getword(z)   (((z)[1] << 8) | ((z)[0] << 0))
#define getlong(z)   (((z)[3] << 24) | ((z)[2] << 16) | ((z)[1] << 8) | ((z)[0] << 0))

int main(int argc, char **argv)
{
	int i,j;
	char output[128];

	if (argc < 2) {
		printf ("File name:\n");
		gets(output);
	} else {
		strcpy (output, argv[1]);
	}

	FILE *fa = fopen(output, "rb");
	fseek (fa, 0, SEEK_END);
	int len = ftell (fa);
	rewind (fa);

	unsigned char *src = (unsigned char*)malloc(len);

	fread (src, len, 1, fa);
	fclose (fa);

	{
		if (src[0] != 'A' || src[1] != 'R' || src[2] != 'C' || src[3] != 0) {
			printf ("Invalid archive!\n");
			return 1;
		}

	//	unsigned short unknown0    = getword(src + 0x04); // always 0x0100 ???
		unsigned short table_size  = getword(src + 0x06);
	//	unsigned short table_size1 = getword(src + 0x08);

		unsigned char main_archive_name[0x20]; // archive names 0x20 chars max?
		memcpy (main_archive_name, src + 0x010, 0x20);

		// remove '.' from archive name so that it can be used as a directory name
		for (i = 0; i < strlen(main_archive_name); i++) {
			if (main_archive_name[i] == 0x2e /*.*/) main_archive_name[i] = '_';
		}

		// create a directory with the title of the original archive (internal name)
		sprintf (output, "mkdir %s", main_archive_name);
		system (output);

		int offset = 0x30 + (table_size * 4);
		if ((offset & 0x0c)) offset = (offset | 0x0f) + 1; // align to 16 bytes??

		for (i = 0; i < table_size; i++)
		{
	//		char data_type[4];
			unsigned char data_name[0x20];

			unsigned char *eptr = src + offset;

			unsigned int data_offset = getlong((src + 0x30) + i * 4);

	//		memcpy (data_type, eptr + 0x00, 4);

			unsigned int data_checksum  = getlong(eptr + 0x08); // this is almost definitely a checksum of some sort??

	//		unsigned short data_unknown = getword(eptr + 0x0c); //??

			unsigned short data_name_length = getword(eptr + 0x0e);

			memcpy (data_name, eptr + 0x14, data_name_length);

			unsigned int data_size = getlong(src + data_offset);

			sprintf(output, "%s//%s", main_archive_name, data_name);

			printf ("%s, %x, %x, %x\n", output, data_offset, data_checksum, data_size);

			offset += 0x14 + data_name_length-1;
			while (src[offset] == 0) offset++; // ??

			fa = fopen(output, "wb");
			fwrite (src + data_offset + 0x20, data_size, 1, fa);
			fclose (fa);
		}
	}

	free (src);
}
